-- Deja Tweaks

--Register Events
local de = CreateFrame("Frame", "DejaErrorFrame")
	de:RegisterEvent("PLAYER_LOGIN")
	de:RegisterEvent("PLAYER_ENTERING_WORLD")
	de:RegisterEvent("ADDON_LOADED")
	-- de:RegisterEvent("PET_BATTLE_OVER")

	de:SetScript("OnEvent", function(self, event, ...)
		BattlefieldMap_LoadUI();
		BattlefieldMapFrame:ClearAllPoints()
		BattlefieldMapFrame:SetPoint("TOPLEFT", UIParent, "TOPLEFT", 6, -6)
		BattlefieldMapFrame:SetSize(840, 560)

		if SinStatsFrame then
			SinStatsFrame:ClearAllPoints()
			SinStatsFrame:SetPoint("TOP", UIParent, "BOTTOM", -276, 136)
		end		
		if UnitName("player") == "Naxximilian" then
			if PlayerFrame then
				PlayerFrame:ClearAllPoints()
				PlayerFrame:SetPoint("CENTER", UIParent, "CENTER", -316, 0)
			end		
			if TargetFrame then
				TargetFrame:ClearAllPoints()
				TargetFrame:SetPoint("CENTER", UIParent, "CENTER", 316, 0)
			end
		end
	end)

--Slash Commands
	SlashCmdList['RELOADUI'] = function() ReloadUI() end
	SLASH_RELOADUI1 = '/rl'

	SlashCmdList["READYCHECK"] = function() DoReadyCheck() end
	SLASH_READYCHECK1 = '/rc'

	SlashCmdList["CHECKROLE"] = function() InitiateRolePoll() end
	SLASH_CHECKROLE1 = '/cr'

local voiceID = C_TTSSettings.GetVoiceOptionID(0)
local playbackOption = Enum.VoiceTtsDestination.LocalPlayback
local speechRate = C_TTSSettings.GetSpeechRate()
local speechVolume = C_TTSSettings.GetSpeechVolume()

--Sell Junk
local dvSellJunk = CreateFrame("Frame")
	dvSellJunk:RegisterEvent("MERCHANT_SHOW")
	dvSellJunk:SetScript("OnEvent", function()
		for bag = BACKPACK_CONTAINER, NUM_BAG_SLOTS do
			for slot = 1, GetContainerNumSlots(bag) do
				local function DV_SellJunk(bag, slot)
					UseContainerItem(bag, slot)
				end
				local itemLink = GetContainerItemLink(bag, slot)
				if itemLink then
					local itemName, _, itemRarity, _, _, _, _, itemStackCount, _, _, itemSellPrice = GetItemInfo(itemLink)
					if itemRarity == 0 and itemSellPrice > 0 then
						local junkPrint = ""
						if itemStackCount > 1 then
							--Money text
							junkPrint = string.format("Sold %s %s for %s (@ %s per) to %s", itemStackCount, itemLink, GetCoinText(itemSellPrice*itemStackCount), GetCoinText(itemSellPrice), UnitName("target"))
							
							--Icons isntead of money text
								-- junkPrint = string.format("Sold %s %s for %s (@ %s per) to %s", itemStackCount, itemLink, GetCoinTextureString(itemSellPrice*itemStackCount, 10), GetCoinTextureString(itemSellPrice, 8), UnitName("target"))
							
							DEFAULT_CHAT_FRAME:AddMessage(junkPrint);
						else
							--Money text
							junkPrint = string.format("Sold %s for %s to %s", itemLink, GetCoinText(itemSellPrice), UnitName("target"))
							
							--Icons isntead of money text
								-- junkPrint = string.format("Sold %s for %s to %s", itemLink, GetCoinTextureString(itemSellPrice, 10), UnitName("target"))
							
							DEFAULT_CHAT_FRAME:AddMessage(junkPrint);
						end
						DV_SellJunk(bag, slot)
						-- if C_VoiceChat.IsTranscriptionAllowed() then
						-- 	C_VoiceChat.SpeakText(voiceID, junkPrint, playbackOption, speechRate, speechVolume)
						-- end
					end
				end
			end
		end
end)

local function repairPrint(source, cost)
	if source == playerPaid then
		repairPrint = string.format("|cffffff00Repair costs covered by "..UnitName("player")..": %s.|r", GetCoinText(cost))
	elseif source == playerNSF then
		repairPrint = string.format("|cffff0000"..UnitName("player").." has insufficient funds to cover repair costs.|r")
	elseif source == guildPaid then
		repairPrint = string.format("|cffffff00Repair costs covered by "..GetGuildInfo("player")..": %s.|r", GetCoinText(cost))
	elseif source == guildNSF then
		repairPrint = string.format("|cffff0000"..UnitName("player").." has insufficient <"..GetGuildInfo("player").."> funds remaining to cover repair costs.|r")
	end
	DEFAULT_CHAT_FRAME:AddMessage(repairPrint)
	-- if C_VoiceChat.IsTranscriptionAllowed() then
	-- 	C_VoiceChat.SpeakText(voiceID, repairPrint, playbackOption, speechRate, speechVolume)
	-- end
end

local function playerRepair(cost, playerHasFunds)
	if playerHasFunds then
		repairPrint(playerPaid, cost)
		RepairAllItems()
	else
		repairPrint(playerNSF, cost)
	end
end

--Auto Repair (AFTER selling junk to avoid false negatives.)
local gbautoRepair = CreateFrame("Frame")
	gbautoRepair:RegisterEvent("MERCHANT_SHOW")
	gbautoRepair:SetScript("OnEvent", function()
		local cost, canRepair = GetRepairAllCost()
		local funds = GetMoney()
		local playerHasFunds = (funds >= cost)
		local guildHasFunds = (GetGuildBankWithdrawMoney() >= cost)

		if(cost and canRepair) then --If there is repair costs and the merchant can repair.
			if IsInGuild() then
				if guildHasFunds then
					repairPrint(guildPaid, cost)
					RepairAllItems(true)
				else
					repairPrint(guildNSF, cost)
					playerRepair(cost, playerHasFunds)
				end
			else
				playerRepair(cost, playerHasFunds)
			end
		end
	end)
	
--Choonster's Spell Off Cursor Button
local b = CreateFrame("Button", "SpellStopTargetingButton", UIParent, "SecureActionButtonTemplate")
	b:SetAttribute("type", "stop")
	
--eAlign by Eurytus

SLASH_EA1 = "/align"

local f

SlashCmdList["EA"] = function()
	if f then
		f:Hide()
		f = nil		
	else
		f = CreateFrame('Frame', nil, UIParent) 
		f:SetAllPoints(UIParent)
		local w = GetScreenWidth() / 64
		local h = GetScreenHeight() / 36
		for i = 0, 64 do
			local t = f:CreateTexture(nil, 'BACKGROUND')
			if i == 32 then
				t:SetColorTexture(1, 0, 0, 0.5)
			else
				t:SetColorTexture(0, 0, 0, 0.5)
			end
			t:SetPoint('TOPLEFT', f, 'TOPLEFT', i * w - 1, 0)
			t:SetPoint('BOTTOMRIGHT', f, 'BOTTOMLEFT', i * w + 1, 0)
		end
		for i = 0, 36 do
			local t = f:CreateTexture(nil, 'BACKGROUND')
			if i == 18 then
				t:SetColorTexture(1, 0, 0, 0.5)
			else
				t:SetColorTexture(0, 0, 0, 0.5)
			end
			t:SetPoint('TOPLEFT', f, 'TOPLEFT', 0, -i * h + 1)
			t:SetPoint('BOTTOMRIGHT', f, 'TOPRIGHT', 0, -i * h - 1)
		end	
	end
end

---------------
-- World Map --
---------------

-- local _, private = ...
-- 	private.defaults.dvdefaults.WorldMapFrameSetPoints = {
-- 		point = "TOPLEFT", 
-- 		relativeTo = "UIParent", 
-- 		relativePoint = "TOPLEFT", 
-- 		xOffset = 0, 
-- 		yOffset = 0,
-- 	}	
	
-- -- Information Stat Frame Parent
-- 	WorldMapFrame:SetClampedToScreen(true)
-- 	WorldMapFrame:SetMovable(true) 
-- 	WorldMapFrame:EnableMouse(true)
-- 	WorldMapFrame:RegisterForDrag("LeftButton")

-- 	WorldMapFrame:HookScript("OnShow", function(self)
-- 		WorldMapFrame.BlackoutFrame:Hide()
-- 		WorldMapFrame.BlackoutFrame.Blackout:Hide()
		
-- 		local function DVC_MoveWMap()
-- 			local point = private.db.dvdefaults.WorldMapFrameSetPoints
-- 				self:ClearAllPoints()		
-- 				self:SetPoint(
-- 					point.point, 
-- 					point.relativeTo, 
-- 					point.relativePoint, 
-- 					point.xOffset, 
-- 					point.yOffset)
-- 		end
-- 		C_Timer.After(0.0001, DVC_MoveWMap)
-- 	end)
	
-- 	WorldMapFrame:HookScript("OnDragStart", WorldMapFrame.StartMoving) 

-- 	WorldMapFrame:HookScript("OnDragStop", function(self) 
-- 		self:StopMovingOrSizing() 
-- 		self:SetUserPlaced(false) 
		
-- 		point, relativeTo, relativePoint, xOfs, yOfs = self:GetPoint(1)
-- 			if ( relativeTo ) then
-- 				relativeTo = relativeTo:GetName();
-- 			else
-- 				relativeTo = self:GetParent():GetName();
-- 			end
	
-- 		-- These are debugging messages for the frame points
-- 		-- Un-comment them to help debug
-- 		-- DEFAULT_CHAT_FRAME:AddMessage(point)
-- 		-- DEFAULT_CHAT_FRAME:AddMessage(relativeTo)
-- 		-- DEFAULT_CHAT_FRAME:AddMessage(relativePoint)
-- 		-- DEFAULT_CHAT_FRAME:AddMessage(xOfs)
-- 		-- DEFAULT_CHAT_FRAME:AddMessage(yOfs)

-- 		private.db.dvdefaults.WorldMapFrameSetPoints.point = point
-- 		private.db.dvdefaults.WorldMapFrameSetPoints.relativeTo = relativeTo
-- 		private.db.dvdefaults.WorldMapFrameSetPoints.relativePoint = relativePoint
-- 		private.db.dvdefaults.WorldMapFrameSetPoints.xOffset = xOfs
-- 		private.db.dvdefaults.WorldMapFrameSetPoints.yOffset = yOfs			
-- 	end)


-- 	local _, private = ...
-- 	private.defaults.dvdefaults.WMSliderSetScale = {
-- 		WorldMapScale = 0.50,
-- 	}	


-- -- WorldMap Slider:
-- local WMSlider = CreateFrame("Slider", "WMSlider", WorldMapFrame, "OptionsSliderTemplate")
-- 	WMSlider:RegisterEvent("PLAYER_LOGIN")
-- 	WMSlider:RegisterEvent("PLAYER_ENTERING_WORLD")
-- 	WMSlider:RegisterEvent("ADDON_LOADED")
-- 	WMSlider:SetPoint("TOPLEFT", WorldMapFrame, "TOPLEFT", 25, -37)
-- 	WMSlider:SetWidth(200)
-- 	WMSlider:SetHeight(10)
-- 	WMSlider:SetOrientation('HORIZONTAL')
-- 	WMSlider:SetMinMaxValues(0.25, 1.0)
-- 	WMSlider.minValue, WMSlider.maxValue = WMSlider:GetMinMaxValues() 
-- 	WMSlider:SetValueStep(0.01)
-- 	WMSlider:SetObeyStepOnDrag(true)

-- 	WMSlider.tooltipText = 'Scale the WorldMap in increments or decrements of 5' --Creates a tooltip on mouseover.

-- 	getglobal(WMSlider:GetName() .. 'Low'):SetText(WMSlider.minValue); --Sets the left-side slider text (default is "Low").
-- 	getglobal(WMSlider:GetName() .. 'High'):SetText(WMSlider.maxValue); --Sets the right-side slider text (default is "High").

-- WorldMapFrame.ScrollContainer.GetCursorPosition = function(f)
-- 	local x,y = MapCanvasScrollControllerMixin.GetCursorPosition(f);
-- 	local s = WorldMapFrame:GetScale();
-- 	return x/s, y/s;
-- end

-- 	WMSlider:SetScript("OnEvent", function(self, event, arg1)
-- 		if event == "PLAYER_LOGIN" then
-- 		local slideValue = private.db.dvdefaults.WMSliderSetScale.WorldMapScale
-- 			WMSlider:SetValue(slideValue)
-- 			WorldMapFrame:SetScale(slideValue)
-- 			getglobal(WMSlider:GetName() .. 'Text'):SetFormattedText("WorldMap Scale = (%.2f)", (slideValue)); --Sets the "title" text (top-centre of slider).
-- 			if GetCVarBool("textToSpeech") then
-- 				print(GetCVarBool("textToSpeech"))
-- 				C_VoiceChat.SpeakText(voiceID, "Text to speech is still enabled.", playbackOption, speechRate, speechVolume)
-- 			end
-- 		end
-- 		WorldMapFrame.ScrollContainer.GetCursorPosition()
-- 	end)

-- 	WorldMapFrame.BorderFrame:SetScript("OnMouseWheel", function(self, input)
-- 		local slideValue = private.db.dvdefaults.WMSliderSetScale.WorldMapScale
-- 		if input > 0 and slideValue < 1 then
-- 			slideValue = (slideValue + 0.01)
-- 			if slideValue > 1 then slideValue = 1 end
-- 			WorldMapFrame:SetScale(slideValue)
-- 		elseif input < 0 and slideValue > 0.25 then
-- 			slideValue = (slideValue - 0.01)
-- 			if slideValue < 0.25 then slideValue = 0.25 end
-- 			WorldMapFrame:SetScale(slideValue)
-- 		end
-- 		getglobal(WMSlider:GetName() .. 'Text'):SetFormattedText("World Map Scale = (%.2f)", (slideValue)); --Sets the "title" text (top-centre of slider).
-- 		private.db.dvdefaults.WMSliderSetScale.WorldMapScale = slideValue
-- 		WMSlider:SetValue(slideValue)
-- 		WorldMapFrame.ScrollContainer.GetCursorPosition()
-- 	end)

-- 	WMSlider:SetScript("OnValueChanged", function(self, value) 
-- 		local slideValue = WMSlider:GetValue()
-- 			WorldMapFrame:SetScale(slideValue)
						
-- 			getglobal(WMSlider:GetName() .. 'Text'):SetFormattedText("World Map Scale = (%.2f)", (slideValue)); --Sets the "title" text (top-centre of slider).
-- 			private.db.dvdefaults.WMSliderSetScale.WorldMapScale = slideValue
-- 			WorldMapFrame.ScrollContainer.GetCursorPosition()
-- 		end)